/***************************************************************************
                           imdft.h  -  description
                             -------------------
   Implementation of the AC-3 IMDFT process.
                             -------------------
    begin                : Mon Oct 24 2005
    copyright            : (C) 2005 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _IMDFT_H_
#define _IMDFT_H_

#include "common/typedefs.h"
#include "audio_block.h"

#ifdef __cplusplus
extern "C" {
#endif

void AC3_imdft512(AC3_COEFF *data);

#if defined(__MMX__) && (AC3_COEFF_SIZE == 16) && defined(_AC3_MMX_)
void AC3_imdft256(AC3_COEFF *data);
#else
void AC3_imdft256_half(AC3_COEFF *data);
# define AC3_imdft256(data) \
     AC3_imdft256_half(data); \
     AC3_imdft256_half(data+1)
#endif

#ifdef __cplusplus
};
#endif

#endif

