/***************************************************************************
                     uncouple_channels.h  -  description
                             -------------------
   Restore the high frequency portion of the coupled channels.
                             -------------------
    begin                : Fri Oct 14 2005
    copyright            : (C) 2005 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _UNCOUPLE_CHANNELS_H_
#define _UNCOUPLE_CHANNELS_H_

#include "audio_block.h"


#define RANDOM_NUM(num, last) \
   num  = -23902 * (s32)(last / 30845); \
   last =  69621 *      (last % 30845); \
   num += (s32)last; \
   if (num < 0) \
      num += 0x7FFFFFFF; \
   last = (u32)num
   
#if (AC3_COEFF_SIZE == 16)
# define GET_DITHER_VALUE(coeff, last) \
{\
   s32 rnd_num; \
   RANDOM_NUM(rnd_num, last); \
   rnd_num -= 0x3FFFFFFF; \
   coeff    = (AC3_COEFF)(rnd_num >> (32-AC3_COEFF_SIZE)); \
}
#elif (AC3_COEFF_SIZE == 32)
# define GET_DITHER_VALUE(coeff, last) \
{\
   RANDOM_NUM(coeff, last); \
   coeff -= 0x3FFFFFFF; \
}
#endif

#ifdef __cplusplus
extern "C" {
#endif

void uncouple_channels(AUDIO_BLOCK *blk);

#ifdef __cplusplus
};
#endif

#endif

