/***************************************************************************
                        layer2_data.h  -  description
                             -------------------
   Functions for handling layer 2 data.
                             -------------------
    begin                : Thu Apr 19 2005
    copyright            : (C) 2005 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _LAYER2_DATA_H_
#define _LAYER2_DATA_H_

#include "common/typedefs.h"
#include "MPEG_audio.h"
#include "dct32.h"

#define LAYER2_read_STATE \
   (MPEG_AUDIO_next_frame_STATE+MPEG_AUDIO_STATE_INC)
#define LAYER2_read_END_STATE \
   (MPEG_AUDIO_next_frame_STATE+(2*MPEG_AUDIO_STATE_INC))
   
#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
   u8   alloc_array[2*32],
        scfsi_array[2*32],
        scalefactor_array[2*32*3];
   AV1  prev_sample_array0[15*32], sample_array0[36*32],
        prev_sample_array1[15*32], sample_array1[36*32];
   const
   u8  *alloc_bits,
       *qindex_table;
   u8  *alloc,
       *scfsi,
       *scalefactor;
   AV1 *sample_gr, *sample;
   s16 *audio_buf;
   u8   bit_shift, data,
        gr, sb, ch, s, qindex, qbits;
} LAYER2_DATA;


/* Processes the layer 2 data in the MPEG_AUDIO_FRAME.
      INPUT: frame - Points to the MPEG_AUDIO_FRAME holding the
                       layer 2 data. This frame does not have
                       to contain all the data. Repeated calls to
                       this function can be used to read the data
                       in parts.
      OUTPUT: layer - Points to the LAYER2_DATA recovered from the
                        MPEG_AUDIO_FRAME. */
void LAYER2_read(MPEG_AUDIO_FRAME *frame,
                 LAYER2_DATA      *layer);

#ifdef __cplusplus
};
#endif

#endif

