/***************************************************************************
                          winmain.h  -  description
                             -------------------
   Handle the all win32 stuff.
                             -------------------
    begin                : Thurs Feb 3 2005
    copyright            : (C) 2005 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _WINMAIN_H_
#define _WINMAIN_H_

#ifndef WIN32_LEAN_AND_MEAN
# define WIN32_LEAN_AND_MEAN
#endif
#include <windows.h>
#include <ddraw.h>

#include "common/typedefs.h"


#define DWEXSTYLE          0
#define DWSTYLE            WS_OVERLAPPEDWINDOW
#define MENU_PRESENT       TRUE
#define WIN_MODE_NORMAL    0
#define WIN_MODE_MINIMIZED 1
#define WIN_MODE_MAXIMIZED 2
#define WIN_MODE_SEL_PROG  4
#define WIN_MODE_SEL_STR   8

extern const char         *ERRMSG_TITLE;
extern HINSTANCE           app;
extern HWND                win;
extern LPDIRECTDRAW        lpDD;
extern LPDIRECTDRAWSURFACE surface,
                           overlay,
                           overlay_back;
extern u32                 overlay_colour,
                           win_mode,
                           screen_wid, screen_hgt,
                           win_wid, win_hgt;
extern int                 win_x, win_y;


#ifdef __cplusplus
extern "C" {
#endif

void resize_DirectDrawOverlay();
void get_win_size(u32 disp_wid, u32 disp_hgt);

#ifdef __cplusplus
};
#endif

#endif

